Hex Artifact Content

Artifact cad3e760731ef0428d52f737c057821857cf9f7a:


0000: 23 21 20 2f 75 73 72 2f 62 69 6e 2f 65 6e 76 20  #! /usr/bin/env 
0010: 62 61 73 68 0a 0a 69 66 20 5b 20 21 20 2d 66 20  bash..if [ ! -f 
0020: 27 62 75 69 6c 64 2e 73 68 27 20 5d 3b 20 74 68  'build.sh' ]; th
0030: 65 6e 0a 09 65 63 68 6f 20 27 45 52 52 4f 52 3a  en..echo 'ERROR:
0040: 20 54 68 69 73 20 73 63 72 69 70 74 20 6d 75 73   This script mus
0050: 74 20 62 65 20 72 75 6e 20 66 72 6f 6d 20 74 68  t be run from th
0060: 65 20 64 69 72 65 63 74 6f 72 79 20 69 74 20 69  e directory it i
0070: 73 20 69 6e 27 20 3e 26 32 0a 0a 09 65 78 69 74  s in' >&2...exit
0080: 20 31 0a 66 69 0a 69 66 20 5b 20 2d 7a 20 22 24   1.fi.if [ -z "$
0090: 7b 54 43 4c 56 45 52 53 7d 22 20 5d 3b 20 74 68  {TCLVERS}" ]; th
00a0: 65 6e 0a 09 65 63 68 6f 20 27 45 52 52 4f 52 3a  en..echo 'ERROR:
00b0: 20 54 68 65 20 54 43 4c 56 45 52 53 20 65 6e 76   The TCLVERS env
00c0: 69 72 6f 6e 6d 65 6e 74 20 76 61 72 69 61 62 6c  ironment variabl
00d0: 65 20 69 73 20 6e 6f 74 20 73 65 74 27 20 3e 26  e is not set' >&
00e0: 32 0a 0a 09 65 78 69 74 20 31 0a 66 69 0a 0a 54  2...exit 1.fi..T
00f0: 43 4c 56 46 53 56 45 52 53 3d 22 32 30 30 38 30  CLVFSVERS="20080
0100: 35 30 33 22 0a 53 52 43 3d 22 73 72 63 2f 74 63  503".SRC="src/tc
0110: 6c 76 66 73 2d 24 7b 54 43 4c 56 46 53 56 45 52  lvfs-${TCLVFSVER
0120: 53 7d 2e 74 61 72 2e 67 7a 22 0a 53 52 43 55 52  S}.tar.gz".SRCUR
0130: 4c 3d 22 68 74 74 70 3a 2f 2f 73 6f 75 72 63 65  L="http://source
0140: 66 6f 72 67 65 2e 6e 65 74 2f 70 72 6f 6a 65 63  forge.net/projec
0150: 74 73 2f 74 63 6c 76 66 73 2f 66 69 6c 65 73 2f  ts/tclvfs/files/
0160: 74 63 6c 76 66 73 2f 74 63 6c 76 66 73 2d 24 7b  tclvfs/tclvfs-${
0170: 54 43 4c 56 46 53 56 45 52 53 7d 2f 74 63 6c 76  TCLVFSVERS}/tclv
0180: 66 73 2d 24 7b 54 43 4c 56 46 53 56 45 52 53 7d  fs-${TCLVFSVERS}
0190: 2e 74 61 72 2e 67 7a 2f 64 6f 77 6e 6c 6f 61 64  .tar.gz/download
01a0: 22 0a 42 55 49 4c 44 44 49 52 3d 22 24 28 70 77  ".BUILDDIR="$(pw
01b0: 64 29 2f 62 75 69 6c 64 2f 74 63 6c 76 66 73 2d  d)/build/tclvfs-
01c0: 24 7b 54 43 4c 56 46 53 56 45 52 53 7d 22 0a 4f  ${TCLVFSVERS}".O
01d0: 55 54 44 49 52 3d 22 24 28 70 77 64 29 2f 6f 75  UTDIR="$(pwd)/ou
01e0: 74 22 0a 49 4e 53 54 44 49 52 3d 22 24 28 70 77  t".INSTDIR="$(pw
01f0: 64 29 2f 69 6e 73 74 22 0a 50 41 54 43 48 44 49  d)/inst".PATCHDI
0200: 52 3d 22 24 28 70 77 64 29 2f 70 61 74 63 68 65  R="$(pwd)/patche
0210: 73 22 0a 65 78 70 6f 72 74 20 54 43 4c 56 46 53  s".export TCLVFS
0220: 56 45 52 53 20 53 52 43 20 53 52 43 55 52 4c 20  VERS SRC SRCURL 
0230: 42 55 49 4c 44 44 49 52 20 4f 55 54 44 49 52 20  BUILDDIR OUTDIR 
0240: 49 4e 53 54 44 49 52 20 50 41 54 43 48 44 49 52  INSTDIR PATCHDIR
0250: 0a 0a 23 20 53 65 74 20 63 6f 6e 66 69 67 75 72  ..# Set configur
0260: 65 20 6f 70 74 69 6f 6e 73 20 66 6f 72 20 74 68  e options for th
0270: 69 73 20 73 75 62 2d 70 72 6f 6a 65 63 74 0a 4c  is sub-project.L
0280: 44 46 4c 41 47 53 3d 22 24 7b 4b 43 5f 54 43 4c  DFLAGS="${KC_TCL
0290: 56 46 53 5f 4c 44 46 4c 41 47 53 7d 22 0a 43 46  VFS_LDFLAGS}".CF
02a0: 4c 41 47 53 3d 22 24 7b 4b 43 5f 54 43 4c 56 46  LAGS="${KC_TCLVF
02b0: 53 5f 43 46 4c 41 47 53 7d 22 0a 43 50 50 46 4c  S_CFLAGS}".CPPFL
02c0: 41 47 53 3d 22 24 7b 4b 43 5f 54 43 4c 56 46 53  AGS="${KC_TCLVFS
02d0: 5f 43 50 50 46 4c 41 47 53 7d 22 0a 4c 49 42 53  _CPPFLAGS}".LIBS
02e0: 3d 22 24 7b 4b 43 5f 54 43 4c 56 46 53 5f 4c 49  ="${KC_TCLVFS_LI
02f0: 42 53 7d 22 0a 65 78 70 6f 72 74 20 4c 44 46 4c  BS}".export LDFL
0300: 41 47 53 20 43 46 4c 41 47 53 20 43 50 50 46 4c  AGS CFLAGS CPPFL
0310: 41 47 53 20 4c 49 42 53 0a 0a 72 6d 20 2d 72 66  AGS LIBS..rm -rf
0320: 20 27 62 75 69 6c 64 27 20 27 6f 75 74 27 20 27   'build' 'out' '
0330: 69 6e 73 74 27 0a 6d 6b 64 69 72 20 27 62 75 69  inst'.mkdir 'bui
0340: 6c 64 27 20 27 6f 75 74 27 20 27 69 6e 73 74 27  ld' 'out' 'inst'
0350: 20 7c 7c 20 65 78 69 74 20 31 0a 0a 54 43 4c 5f   || exit 1..TCL_
0360: 56 45 52 53 49 4f 4e 3d 22 75 6e 6b 6e 6f 77 6e  VERSION="unknown
0370: 22 0a 69 66 20 5b 20 2d 66 20 22 24 7b 54 43 4c  ".if [ -f "${TCL
0380: 43 4f 4e 46 49 47 44 49 52 7d 2f 74 63 6c 43 6f  CONFIGDIR}/tclCo
0390: 6e 66 69 67 2e 73 68 22 20 5d 3b 20 74 68 65 6e  nfig.sh" ]; then
03a0: 0a 09 73 6f 75 72 63 65 20 22 24 7b 54 43 4c 43  ..source "${TCLC
03b0: 4f 4e 46 49 47 44 49 52 7d 2f 74 63 6c 43 6f 6e  ONFIGDIR}/tclCon
03c0: 66 69 67 2e 73 68 22 0a 66 69 0a 65 78 70 6f 72  fig.sh".fi.expor
03d0: 74 20 54 43 4c 5f 56 45 52 53 49 4f 4e 0a 0a 69  t TCL_VERSION..i
03e0: 66 20 5b 20 21 20 2d 66 20 22 24 7b 53 52 43 7d  f [ ! -f "${SRC}
03f0: 22 20 5d 3b 20 74 68 65 6e 0a 09 6d 6b 64 69 72  " ]; then..mkdir
0400: 20 27 73 72 63 27 20 3e 2f 64 65 76 2f 6e 75 6c   'src' >/dev/nul
0410: 6c 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c 0a 0a 09  l 2>/dev/null...
0420: 69 66 20 5b 20 21 20 2d 64 20 27 62 75 69 6c 64  if [ ! -d 'build
0430: 73 72 63 27 20 5d 3b 20 74 68 65 6e 0a 09 09 72  src' ]; then...r
0440: 6d 20 2d 66 20 22 24 7b 53 52 43 7d 2e 74 6d 70  m -f "${SRC}.tmp
0450: 22 0a 09 09 77 67 65 74 20 2d 4f 20 22 24 7b 53  "...wget -O "${S
0460: 52 43 7d 2e 74 6d 70 22 20 22 24 7b 53 52 43 55  RC}.tmp" "${SRCU
0470: 52 4c 7d 22 20 7c 7c 20 65 78 69 74 20 31 0a 09  RL}" || exit 1..
0480: 09 6d 76 20 22 24 7b 53 52 43 7d 2e 74 6d 70 22  .mv "${SRC}.tmp"
0490: 20 22 24 7b 53 52 43 7d 22 0a 09 66 69 0a 66 69   "${SRC}"..fi.fi
04a0: 0a 0a 28 0a 09 63 64 20 27 62 75 69 6c 64 27 20  ..(..cd 'build' 
04b0: 7c 7c 20 65 78 69 74 20 31 0a 0a 09 69 66 20 5b  || exit 1...if [
04c0: 20 21 20 2d 64 20 27 2e 2e 2f 62 75 69 6c 64 73   ! -d '../builds
04d0: 72 63 27 20 5d 3b 20 74 68 65 6e 0a 09 09 67 7a  rc' ]; then...gz
04e0: 69 70 20 2d 64 63 20 22 2e 2e 2f 24 7b 53 52 43  ip -dc "../${SRC
04f0: 7d 22 20 7c 20 74 61 72 20 2d 78 66 20 2d 0a 09  }" | tar -xf -..
0500: 65 6c 73 65 20 20 20 20 0a 09 09 63 70 20 2d 72  else    ...cp -r
0510: 70 20 2e 2e 2f 62 75 69 6c 64 73 72 63 2f 2a 20  p ../buildsrc/* 
0520: 27 2e 2f 27 0a 09 66 69 0a 0a 09 63 64 20 22 24  './'..fi...cd "$
0530: 7b 42 55 49 4c 44 44 49 52 7d 22 20 7c 7c 20 65  {BUILDDIR}" || e
0540: 78 69 74 20 31 0a 0a 20 20 20 20 20 20 20 20 23  xit 1..        #
0550: 20 41 70 70 6c 79 20 72 65 71 75 69 72 65 64 20   Apply required 
0560: 70 61 74 63 68 65 73 0a 09 66 6f 72 20 70 61 74  patches..for pat
0570: 63 68 20 69 6e 20 22 24 7b 50 41 54 43 48 44 49  ch in "${PATCHDI
0580: 52 7d 2f 61 6c 6c 22 2f 74 63 6c 76 66 73 2d 24  R}/all"/tclvfs-$
0590: 7b 54 43 4c 56 46 53 56 45 52 53 7d 2d 2a 2e 64  {TCLVFSVERS}-*.d
05a0: 69 66 66 20 22 24 7b 50 41 54 43 48 44 49 52 7d  iff "${PATCHDIR}
05b0: 2f 24 7b 54 43 4c 5f 56 45 52 53 49 4f 4e 7d 22  /${TCL_VERSION}"
05c0: 2f 74 63 6c 76 66 73 2d 24 7b 54 43 4c 56 46 53  /tclvfs-${TCLVFS
05d0: 56 45 52 53 7d 2d 2a 2e 64 69 66 66 3b 20 64 6f  VERS}-*.diff; do
05e0: 0a 09 09 69 66 20 5b 20 21 20 2d 66 20 22 24 7b  ...if [ ! -f "${
05f0: 70 61 74 63 68 7d 22 20 5d 3b 20 74 68 65 6e 0a  patch}" ]; then.
0600: 09 09 09 63 6f 6e 74 69 6e 75 65 0a 09 09 66 69  ...continue...fi
0610: 0a 0a 09 09 65 63 68 6f 20 22 41 70 70 6c 79 69  ....echo "Applyi
0620: 6e 67 3a 20 24 7b 70 61 74 63 68 7d 22 0a 09 09  ng: ${patch}"...
0630: 24 7b 50 41 54 43 48 3a 2d 70 61 74 63 68 7d 20  ${PATCH:-patch} 
0640: 2d 70 31 20 3c 20 22 24 7b 70 61 74 63 68 7d 22  -p1 < "${patch}"
0650: 0a 09 64 6f 6e 65 20 20 20 20 20 20 20 20 20 20  ..done          
0660: 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20                  
0670: 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20                  
0680: 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20                  
0690: 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20                  
06a0: 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20                  
06b0: 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20                  
06c0: 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20                  
06d0: 20 20 20 20 20 0a 0a 09 63 70 20 67 65 6e 65 72       ...cp gener
06e0: 69 63 2f 76 66 73 2e 63 20 2e 0a 0a 09 23 20 49  ic/vfs.c ....# I
06f0: 66 20 77 65 20 61 72 65 20 62 75 69 6c 64 69 6e  f we are buildin
0700: 67 20 66 6f 72 20 57 69 6e 33 32 2c 20 77 65 20  g for Win32, we 
0710: 6e 65 65 64 20 74 6f 20 64 65 66 69 6e 65 20 54  need to define T
0720: 45 41 5f 50 4c 41 54 46 4f 52 4d 20 73 6f 20 74  EA_PLATFORM so t
0730: 68 61 74 0a 09 23 20 74 68 65 20 72 69 67 68 74  hat..# the right
0740: 20 70 72 69 76 61 74 65 20 64 69 72 65 63 74 6f   private directo
0750: 72 79 20 69 73 20 66 6f 75 6e 64 0a 09 42 55 49  ry is found..BUI
0760: 4c 44 54 59 50 45 3d 22 24 28 62 61 73 65 6e 61  LDTYPE="$(basena
0770: 6d 65 20 22 24 7b 54 43 4c 43 4f 4e 46 49 47 44  me "${TCLCONFIGD
0780: 49 52 7d 22 29 22 0a 09 69 66 20 5b 20 22 24 7b  IR}")"..if [ "${
0790: 42 55 49 4c 44 54 59 50 45 7d 22 20 3d 20 22 77  BUILDTYPE}" = "w
07a0: 69 6e 22 20 5d 3b 20 74 68 65 6e 0a 09 09 54 45  in" ]; then...TE
07b0: 41 5f 50 4c 41 54 46 4f 52 4d 3d 22 77 69 6e 64  A_PLATFORM="wind
07c0: 6f 77 73 22 0a 09 09 65 78 70 6f 72 74 20 54 45  ows"...export TE
07d0: 41 5f 50 4c 41 54 46 4f 52 4d 0a 0a 09 09 43 46  A_PLATFORM....CF
07e0: 4c 41 47 53 3d 22 24 7b 43 46 4c 41 47 53 7d 20  LAGS="${CFLAGS} 
07f0: 2d 49 24 7b 54 43 4c 43 4f 4e 46 49 47 44 49 52  -I${TCLCONFIGDIR
0800: 7d 22 0a 09 09 65 78 70 6f 72 74 20 43 46 4c 41  }"...export CFLA
0810: 47 53 0a 09 66 69 0a 0a 09 23 20 49 66 20 77 65  GS..fi...# If we
0820: 20 61 72 65 20 62 75 69 6c 64 69 6e 67 20 66 6f   are building fo
0830: 72 20 4b 69 74 44 4c 4c 2c 20 63 6f 6d 70 69 6c  r KitDLL, compil
0840: 65 20 77 69 74 68 20 27 2d 66 50 49 43 27 0a 09  e with '-fPIC'..
0850: 69 66 20 5b 20 22 24 7b 4b 49 54 54 41 52 47 45  if [ "${KITTARGE
0860: 54 7d 22 20 3d 20 22 6b 69 74 64 6c 6c 22 20 5d  T}" = "kitdll" ]
0870: 3b 20 74 68 65 6e 0a 09 09 43 46 4c 41 47 53 3d  ; then...CFLAGS=
0880: 22 24 7b 43 46 4c 41 47 53 7d 20 2d 66 50 49 43  "${CFLAGS} -fPIC
0890: 22 0a 09 09 65 78 70 6f 72 74 20 43 46 4c 41 47  "...export CFLAG
08a0: 53 0a 09 66 69 0a 0a 09 23 20 42 75 69 6c 64 20  S..fi...# Build 
08b0: 73 74 61 74 69 63 20 76 65 72 73 69 6f 6e 0a 09  static version..
08c0: 65 63 68 6f 20 22 52 75 6e 6e 69 6e 67 3a 20 2e  echo "Running: .
08d0: 2f 63 6f 6e 66 69 67 75 72 65 20 2d 2d 64 69 73  /configure --dis
08e0: 61 62 6c 65 2d 73 68 61 72 65 64 20 2d 2d 70 72  able-shared --pr
08f0: 65 66 69 78 3d 5c 22 24 7b 49 4e 53 54 44 49 52  efix=\"${INSTDIR
0900: 7d 5c 22 20 2d 2d 65 78 65 63 2d 70 72 65 66 69  }\" --exec-prefi
0910: 78 3d 5c 22 24 7b 49 4e 53 54 44 49 52 7d 5c 22  x=\"${INSTDIR}\"
0920: 20 2d 2d 6c 69 62 64 69 72 3d 5c 22 24 7b 49 4e   --libdir=\"${IN
0930: 53 54 44 49 52 7d 2f 6c 69 62 5c 22 20 2d 2d 77  STDIR}/lib\" --w
0940: 69 74 68 2d 74 63 6c 3d 5c 22 24 7b 54 43 4c 43  ith-tcl=\"${TCLC
0950: 4f 4e 46 49 47 44 49 52 7d 5c 22 20 24 7b 43 4f  ONFIGDIR}\" ${CO
0960: 4e 46 49 47 55 52 45 45 58 54 52 41 7d 22 0a 09  NFIGUREEXTRA}"..
0970: 2e 2f 63 6f 6e 66 69 67 75 72 65 20 2d 2d 64 69  ./configure --di
0980: 73 61 62 6c 65 2d 73 68 61 72 65 64 20 2d 2d 70  sable-shared --p
0990: 72 65 66 69 78 3d 22 24 7b 49 4e 53 54 44 49 52  refix="${INSTDIR
09a0: 7d 22 20 2d 2d 65 78 65 63 2d 70 72 65 66 69 78  }" --exec-prefix
09b0: 3d 22 24 7b 49 4e 53 54 44 49 52 7d 22 20 2d 2d  ="${INSTDIR}" --
09c0: 6c 69 62 64 69 72 3d 22 24 7b 49 4e 53 54 44 49  libdir="${INSTDI
09d0: 52 7d 2f 6c 69 62 22 20 2d 2d 77 69 74 68 2d 74  R}/lib" --with-t
09e0: 63 6c 3d 22 24 7b 54 43 4c 43 4f 4e 46 49 47 44  cl="${TCLCONFIGD
09f0: 49 52 7d 22 20 24 7b 43 4f 4e 46 49 47 55 52 45  IR}" ${CONFIGURE
0a00: 45 58 54 52 41 7d 0a 0a 09 65 63 68 6f 20 22 52  EXTRA}...echo "R
0a10: 75 6e 6e 69 6e 67 3a 20 24 7b 4d 41 4b 45 3a 2d  unning: ${MAKE:-
0a20: 6d 61 6b 65 7d 22 0a 09 24 7b 4d 41 4b 45 3a 2d  make}"..${MAKE:-
0a30: 6d 61 6b 65 7d 20 7c 7c 20 65 78 69 74 20 31 0a  make} || exit 1.
0a40: 0a 09 65 63 68 6f 20 22 52 75 6e 6e 69 6e 67 3a  ..echo "Running:
0a50: 20 24 7b 4d 41 4b 45 3a 2d 6d 61 6b 65 7d 20 69   ${MAKE:-make} i
0a60: 6e 73 74 61 6c 6c 22 0a 09 24 7b 4d 41 4b 45 3a  nstall"..${MAKE:
0a70: 2d 6d 61 6b 65 7d 20 69 6e 73 74 61 6c 6c 20 7c  -make} install |
0a80: 7c 20 65 78 69 74 20 31 0a 0a 09 6d 6b 64 69 72  | exit 1...mkdir
0a90: 20 22 24 7b 4f 55 54 44 49 52 7d 2f 6c 69 62 22   "${OUTDIR}/lib"
0aa0: 20 7c 7c 20 65 78 69 74 20 31 0a 09 63 70 20 2d   || exit 1..cp -
0ab0: 72 20 22 24 7b 49 4e 53 54 44 49 52 7d 2f 6c 69  r "${INSTDIR}/li
0ac0: 62 22 2f 76 66 73 2a 20 22 24 7b 4f 55 54 44 49  b"/vfs* "${OUTDI
0ad0: 52 7d 2f 6c 69 62 2f 22 0a 09 72 6d 20 2d 66 20  R}/lib/"..rm -f 
0ae0: 22 24 7b 4f 55 54 44 49 52 7d 2f 6c 69 62 22 2f  "${OUTDIR}/lib"/
0af0: 76 66 73 2a 2f 2a 2e 61 20 22 24 7b 4f 55 54 44  vfs*/*.a "${OUTD
0b00: 49 52 7d 2f 6c 69 62 22 2f 76 66 73 2a 2f 2a 2e  IR}/lib"/vfs*/*.
0b10: 73 6f 0a 0a 09 65 78 69 74 20 30 0a 29 20 7c 7c  so...exit 0.) ||
0b20: 20 65 78 69 74 20 31 0a 0a 65 78 69 74 20 30 0a   exit 1..exit 0.